/*The game logic for our game
No direct view or user interaction*/
#pragma once
#include<string>

//Make Unreal Friendly Syntax
using int32 = int;
using FString = std::string;

enum class EGuessStatus{ok, Not_Isogram, Wrong_Length, NOT_LOWERCASE, INVALID_STATUS};//see check guess validity

enum class EGameWinStatus{Not_Enough_Bulls, Enough_Bulls, DEFAULT};//see is game won method

//Initialized two values to 0
//increase count based on player guess
struct FBullCowCount 
{
	int32 Bulls = 0;
	int32 Cows = 0;
};//do not forget this semicolon!!!!

class FBullCowGame 
{
private: 
	int32 MyCurrentTry = 0;
	FString MyHiddenWord;
	bool IsIsogram(FString)const;
	bool IsLowerCase(FString)const;
public:
	int32 GetMaxTries() const;
	FString GetHiddenWord()const;
	int32 GetCurrentTry()const;
	int32 GetHiddenWordLength()const;
	EGuessStatus CheckGuessValidity(FString)const; 
	EGameWinStatus IsGameWon(FBullCowCount)const;
	void const Reset();
	FBullCowGame();
	FBullCowCount SubmitValidGuess(FString);//counts bull and cows and increases try number assuming valid guess
};//do not forget this semicolon!!!!
